查看: 1321| 回复: 6
跳转到指定楼层
上一主题 下一主题
收起左侧

[二分/排序/搜索] 基础二分法求解 first bad version,谢谢!

全局:

注册一亩三分地论坛,查看更多干货!

您需要 登录 才可以下载或查看附件。没有帐号?注册账号

x
本帖最后由 flag_off 于 2023-7-11 16:55 编辑

https://leetcode.com/problems/fi...lowing-3-solutions/


就是很基础的二分法,但是楼主一直有个点想不明白,上面的 link 贴了写了 3 种的 solution,第 3 个最简单,但是我要想清楚为什么return left要花一点时间,第1个solution我就比较好理解,第2个类似,就是更繁琐了,加了第二个判断条件。按道理这3个都是 log(n) 复杂度,求问大神他们区别到底在哪里呢?

评分

参与人数 1大米 +1 收起 理由
14417335 + 1 给你点个赞!

查看全部评分


上一篇:LC周赛打不上去了......完了,感觉这辈子是进不了谷歌了
下一篇:如果打印出网络中nodes数量
🔗
红A 2023-7-12 08:02:24 | 只看该作者
全局:
本帖最后由 红A 于 2023-7-11 17:06 编辑

三个解法都不好,不如在第三个解法的基础上用一个res variable来保存最后一次遇到的bad version, 然后遇到bad version一路往左检测,也就是=的时候继续往左,最后一次遇到的 bad version 就是first bad version.

第二个解法面试如果candidate坚持写,我应该会给low readability 的评价
code quality is not reach standard bar, candidate stuggle to keep the logic and code clean, code stil need a lot polishing.
回复

使用道具 举报

🔗
 楼主| flag_off 2023-7-12 08:23:59 | 只看该作者
全局:
红A 发表于 2023-7-11 17:02
三个解法都不好,不如在第三个解法的基础上用一个res variable来保存最后一次遇到的bad version, 然后遇到b ...

谢了,我改了下成这样了:

class Solution {
public:
    int firstBadVersion(int n) {
        int left = 0, right = n - 1, middle;
        int result;
        while (left <= right) {
            middle = left + (right - left) / 2;
            if (isBadVersion(middle)) {
                right = middle - 1;
                result = middle;
            }
            else {
                left = middle + 1;
            }
        }
        return result;
    }
};

评分

参与人数 1大米 +5 收起 理由
红A + 5 给你点个赞!

查看全部评分

回复

使用道具 举报

全局:
三者的区别主要在于可读性,前两个把特殊情况列出来了,来理清自己的代码思路,这很常见;

但第二个加的判断条件有点绕,而且他写的有点乱。
回复

使用道具 举报

🔗
Javery 2023-7-12 17:40:33 | 只看该作者
全局:
红A 发表于 2023-7-12 08:02
三个解法都不好,不如在第三个解法的基础上用一个res variable来保存最后一次遇到的bad version, 然后遇到b ...

这样复杂度不是会被提高吗?因为向左一个一个走其实会变成O(n)

我觉得第三个其实是最好理解的,因为left 和 right本质是区间的两边,有可能是左闭右闭有可能是左闭右开,所以无论右是什么,左即left一定是存在于区间内部的。当收敛到最终状态的时候,即最后一个,剩下的一定是left。

这样理解:After the loop, left is the minimal index satisfying the condition function

评分

参与人数 1大米 +1 收起 理由
flag_off + 1 给你点个赞!

查看全部评分

回复

使用道具 举报

🔗
threadstart 2023-7-12 17:58:46 | 只看该作者
全局:
投第三个解法一票, 第三个解法算是二分法的标准解法了.

这个题里面left指向的是第一个isBadVersion为真的元素, right指向的是最后一个isBadVersion为假的元素. 在其他二分法的题目中也是类似的, left会指向第一个满足特定条件的元素, right会指向最后一个不满足那个条件的元素.

把C++里面std::lower_bound, std::upper_bound和std::equal_range弄明白就对二分法的边界结果会有很深刻的认识了

评分

参与人数 1大米 +1 收起 理由
flag_off + 1 给你点个赞!

查看全部评分

回复

使用道具 举报

🔗
红A 2023-7-13 00:55:49 | 只看该作者
全局:
Javery 发表于 2023-7-12 02:40
这样复杂度不是会被提高吗?因为向左一个一个走其实会变成O(n)

我觉得第三个其实是最好理解的,因为le ...

第三个解法的基础上加的res,还是logn

评分

参与人数 1大米 +1 收起 理由
flag_off + 1 给你点个赞!

查看全部评分

回复

使用道具 举报

您需要登录后才可以回帖 登录 | 注册账号
隐私提醒:
  • ☑ 禁止发布广告,拉群,贴个人联系方式:找人请去🔗同学同事飞友,拉群请去🔗拉群结伴,广告请去🔗跳蚤市场,和 🔗租房广告|找室友
  • ☑ 论坛内容在发帖 30 分钟内可以编辑,过后则不能删帖。为防止被骚扰甚至人肉,不要公开留微信等联系方式,如有需求请以论坛私信方式发送。
  • ☑ 干货版块可免费使用 🔗超级匿名:面经(美国面经、中国面经、数科面经、PM面经),抖包袱(美国、中国)和录取汇报、定位选校版
  • ☑ 查阅全站 🔗各种匿名方法

本版积分规则

>
快速回复 返回顶部 返回列表